import * as React from 'react';
import { WrappedComponentProps } from './injectIntl';
import { MessageDescriptor } from '../types';
import { PrimitiveType, FormatXMLElementFn } from 'intl-messageformat';
export interface Props<V extends Record<string, any> = Record<string, React.ReactNode>> extends MessageDescriptor, WrappedComponentProps {
    values?: V;
    tagName?: React.ElementType<any>;
    children?(...nodes: React.ReactNodeArray): React.ReactNode;
}
export declare class BaseFormattedMessage<V extends Record<string, any> = Record<string, PrimitiveType | React.ReactElement | FormatXMLElementFn>> extends React.Component<Props<V>> {
    static defaultProps: {
        values: {};
    };
    static displayName: string;
    constructor(props: Props<V>);
    shouldComponentUpdate(nextProps: Props<V>): boolean;
    render(): {} | null | undefined;
}
declare const _default: (React.ComponentClass<import("./injectIntl").WithIntlProps<Props<Record<string, any>>>, any> & {
    WrappedComponent: React.ComponentType<Props<Record<string, any>>>;
}) | (React.FunctionComponent<import("./injectIntl").WithIntlProps<Props<Record<string, any>>>> & {
    WrappedComponent: React.ComponentType<Props<Record<string, any>>>;
});
export default _default;
