import { Formatters, IntlConfig, MessageDescriptor, IntlFormatters } from './types';
import { PrimitiveType } from 'intl-messageformat';
export declare function formatDate({ locale, formats, onError, timeZone, }: Pick<IntlConfig, 'locale' | 'formats' | 'onError' | 'timeZone'>, state: Formatters, ...[value, options]: Parameters<IntlFormatters['formatDate']>): string;
export declare function formatTime({ locale, formats, onError, timeZone, }: Pick<IntlConfig, 'locale' | 'formats' | 'onError' | 'timeZone'>, state: Formatters, ...[value, options]: Parameters<IntlFormatters['formatTime']>): string;
export declare function formatRelativeTime({ locale, formats, onError, }: Pick<IntlConfig, 'locale' | 'formats' | 'onError'>, state: Formatters, ...[value, unit, options]: Parameters<IntlFormatters['formatRelativeTime']>): string;
export declare function formatNumber({ locale, formats, onError, }: Pick<IntlConfig, 'locale' | 'formats' | 'onError'>, state: Formatters, ...[value, options]: Parameters<IntlFormatters['formatNumber']>): string;
export declare function formatPlural({ locale, onError }: Pick<IntlConfig, 'locale' | 'onError'>, state: Formatters, ...[value, options]: Parameters<IntlFormatters['formatPlural']>): string;
export declare function formatMessage({ locale, formats, messages, defaultLocale, defaultFormats, onError, }: Pick<IntlConfig, 'locale' | 'formats' | 'messages' | 'defaultLocale' | 'defaultFormats' | 'onError'>, state: Formatters, messageDescriptor?: MessageDescriptor, values?: Record<string, PrimitiveType>): string;
export declare function formatHTMLMessage(config: Pick<IntlConfig, 'locale' | 'formats' | 'messages' | 'defaultLocale' | 'defaultFormats' | 'onError'>, state: Formatters, messageDescriptor?: MessageDescriptor, rawValues?: Record<string, PrimitiveType>): string;
export declare const formatters: {
    formatNumber: typeof formatNumber;
    formatDate: typeof formatDate;
    formatTime: typeof formatTime;
    formatMessage: typeof formatMessage;
    formatPlural: typeof formatPlural;
    formatHTMLMessage: typeof formatHTMLMessage;
    formatRelativeTime: typeof formatRelativeTime;
};
